#!/usr/local/bin/perl
# restore.cgi
# Actually restore some files from the mounted tape

require './bacula-restore-lib.pl';
&ReadParse();
-d $in{'rto'} || mkdir($in{'rto'}, 0755) || &error($text{'restore_erto'});

&header($text{'restore_title'}, "");
print "<hr>\n";

@files = split(/\0/, $in{'file'});
$temp = &tempname();
open(TEMP, ">$temp");
foreach $f (@files) {
	print TEMP $f,"\n";
	}
close(TEMP);

# Create a bootstrap file
$strap = &tempname();
open(TEMP, ">$strap");
print TEMP "Volume = $in{'vol'}\n";
print TEMP "JobID = $in{'job'}\n";
close(TEMP);

# Lookup the job name
$dbh = &connect_to_database();
$cmd = $dbh->prepare("
select Name from Job where JobId = ?
");
$cmd || &error(&text('esql', $dbh->errstr));
$cmd->execute($in{'job'});
($jobname) = $cmd->fetchrow();
$cmd->finish();

print "<b>",&text('restore_now', scalar(@files), "<tt>$in{'vol'}</tt>",
				 "<tt>$jobname</tt>"),"</b><p>\n";
print "<font size=1>\n";
if (-c $in{'tape'} || -b $in{'tape'}) {
	$rd = $in{'tape'};
	}
else {
	($rd = $in{'tape'}) =~ s/\/([^\/]+)$//;
	}
open(RESTORE, "cd $config{'bacula_dir'} ; $config{'bextract'} -V '$in{'vol'}' -b $strap -i $temp '$rd' '$in{'rto'}' 2>&1 |");
while(<RESTORE>) {
	print "<tt>",&html_escape($_),"</tt><br>\n";
	}
close(RESTORE);
unlink($strap);
print "</font><p>\n";
if ($?) {
	print "<b>$text{'restore_failed'}</b><p>\n";
	}
else {
	print "<b>$text{'restore_done'}</b><p>\n";
	}
unlink($temp);

print "<hr>\n";
&footer("", $text{'index_return'});
