#!/usr/local/bin/perl
# check_tape.cgi
# Find out which volume is on the specified tape, and allow selection of
# files from that volumn

require './bacula-restore-lib.pl';
&ReadParse();
$in{'tape'} ||= $in{'other'};
$in{'tape'} =~ /^\// || &error($text{'check_etape'});
&header($text{'check_title'}, "");
print "<hr>\n";

# Try to identify the tape .. use btape first
$out = `cd $config{'bacula_dir'} ; echo read | $config{'btape'} '$in{'tape'}' 2>&1`;
if ($out =~ /VolName\s*:\s*(\S+)/i && !$?) {
	$vol = $1;
	}
else {
	# Fall back to bls
	$out2 = `cd $config{'bacula_dir'} ; $config{'bls'} -j '$in{'tape'}' 2>&1`;
	if ($out2 =~ /from volume "(.*)"/i && !$?) {
		$vol = $1;
		}
	}

if (!$vol) {
	print "<p>$text{'check_evol'}\n";
	print "<pre>$out</pre>\n";
	print "<p>\n";
	print "<pre>$out2</pre>\n";
	}
else {
	# Got it .. show form
	$dbh = &connect_to_database();
	print &text('check_desc', "<tt>$vol</tt>"),"<p>\n";
	print "<form action=search_files.cgi method=post>\n";
	print "<input type=hidden name=vol value='$vol'>\n";
	print "<input type=hidden name=tape value='$in{'tape'}'>\n";
	print "<table border>\n";
	print "<tr $tb> <td><b>$text{'check_header'}</b></td> </tr>\n";
	print "<tr $cb> <td><table width=100%>\n";

	print "<tr> <td valign=top><b>$text{'index_job'}</b></td>\n";
	print "<td>";
	&job_select($dbh, $vol);
	print "</td> </tr>\n";

	print "<tr> <td valign=top><b>$text{'index_files'}</b></td>\n";
	print "<td><textarea name=files rows=8 cols=50></textarea></td>\n";
	print "<td valign=top>",&bacula_file_button("files", "job", $vol),
	      "</td></tr>\n";

	print "</table></td></tr></table>\n";
	print "<input type=submit value='$text{'check_search'}'></form>\n";
	}

print "<hr>\n";
&footer("", $text{'index_return'});

