#!/usr/local/bin/perl
# restore.cgi
# Actually restore some files from the mounted tape
# XXX no need for to directory
# XXX no need for source tape
# XXX will need storage selector

require './bacula-restore-lib.pl';
&foreign_require("proc", "proc-lib.pl");
&ReadParse();
-d $in{'rto'} || mkdir($in{'rto'}, 0755) || &error($text{'restore_erto'});

$| = 1;
$theme_no_table++;
&header($text{'restore_title'}, "");
print "<hr>\n";
@files = split(/\0/, $in{'file'});

#$temp = &tempname();
#open(TEMP, ">$temp");
#foreach $f (@files) {
#	print TEMP $f,"\n";
#	}
#close(TEMP);

# Create a bootstrap file
#$strap = &tempname();
#open(TEMP, ">$strap");
#print TEMP "Volume = $in{'vol'}\n";
#print TEMP "JobID = $in{'job'}\n";
#close(TEMP);

# Lookup the job name
$dbh = &connect_to_database();
$cmd = $dbh->prepare("
select Name from Job where JobId = ?
");
$cmd || &error(&text('esql', $dbh->errstr));
$cmd->execute($in{'job'});
($jobname) = $cmd->fetchrow();
$cmd->finish();

print "<b>",&text('restore_now', scalar(@files), "<tt>$in{'vol'}</tt>",
				 "<tt>$jobname</tt>"),"</b><p>\n";
print "<font size=1>\n";
print "<pre>";

pipe(INr, INw);
pipe(OUTr, OUTw);
if (!($pid = fork())) {
	#&proc::close_controlling_pty();
	untie(*STDIN);
        untie(*STDOUT);
        untie(*STDERR);
	close(STDIN);
	close(STDOUT);
	close(STDERR);
	open(STDIN, "<&INr");
	open(STDOUT, ">&OUTw");
	open(STDERR, ">&OUTw");
	$| = 1;
	close(INw); close(OUTr);
	#&proc::open_controlling_pty(undef, "INr");
	chdir($config{'bacula_dir'});
	exec($config{'console'});
	print STDERR "exec failed : $!\n";
	exit(1);
	}
close(INr);
close(OUTw);
$infh = INw;
$outfh = OUTr;
select($infh); $| = 1; select(STDOUT);
select($outfh); $| = 1; select(STDOUT);

#&wait_for($outfh, "OK");
print $wait_for_input;

print $infh "restore client=$in{'client'} jobid=$in{'job'}\n";
&wait_for($outfh, "\\\$");
print $wait_for_input;

print $infh "unmark *\n";
&wait_for($outfh, "\\\$");
print $wait_for_input;

foreach $f (@files) {
	$f = &unix_to_dos($f);
	if ($f eq "/") {
		print $infh "cd /\n";
		&wait_for($outfh, "\\\$");
		print $wait_for_input;

		print $infh "mark *\n";
		&wait_for($outfh, "\\\$");
		print $wait_for_input;
		}
	elsif ($f =~ /^(.*)\/([^\/]+)\/?$/) {
		local ($fd, $ff) = ($1, $2);
		print $infh "cd \"$fd\"\n";
		&wait_for($outfh, "\\\$");
		print $wait_for_input;

		print $infh "mark \"$ff\"\n";
		&wait_for($outfh, "\\\$");
		print $wait_for_input;
		}
	}

print $infh "done\n";
&wait_for($outfh, "OK to run.*:");
print $wait_for_input;

print $infh "yes\n";
#&wait_for($outfh, "command done", "Job started");
#print $wait_for_input;

print $infh "quit\n";
close($fh);
kill('TERM', $pid);

print "</pre></font><p>\n";
if ($?) {
	print "<b>$text{'restore_failed'}</b><p>\n";
	}
else {
	print "<b>$text{'restore_done'}</b><p>\n";
	}
unlink($temp);

print "<hr>\n";
&footer("", $text{'index_return'});
